#ifndef SCU
#include "allhyper.h"
#endif

int TSIZE = 4096;

string its05(int i) { char buf[64]; sprintf(buf, "%05d", i); return buf; }

void odsvideo(int num) {
#if !ISANDROID
#if CAP_ODS
  dynamicval<stereo::eStereo> d(stereo::mode, stereo::sODS);
#endif
  resetbuffer rb;
  renderbuffer rbuf(TSIZE, TSIZE, true);

  for(int i=0; i<num; i++) {
    ticks = num * 1000 / 30;
    rug::prepareTexture();

    rbuf.enable();
    dynamicval<int> vx(vid.xres, TSIZE);
    dynamicval<int> vy(vid.yres, TSIZE);
    dynamicval<int> vxc(vid.xcenter, TSIZE/2);
    dynamicval<int> vyc(vid.ycenter, TSIZE/2);
    stereo::set_viewport(0);
    rug::drawRugScene();
    
    IMAGESAVE(rbuf.render(), ("extra/ods/" + its05(i) + IMAGEEXT).c_str());
    printf("GL %5d/%5d\n", i, num);
    
    rug::push_all_points(2, 2 * M_PI / num);
    }
  
  rb.reset();
#endif
  }

namespace rug {
  extern eGeometry gwhere;
  extern int vertex_limit;
  extern ld modelscale;
  extern bool rug_perspective;
  extern ld model_distance;
  extern ld ruggo;
  extern int renderlate;
  }

extern bool dont_face_pc;

bool started = false;

void enable_rug(eLand l, bool switch_hyperbolic = false) {
  firstland = specialland = l;
  sightrange = 15;
  overgenerate = true;
  
  if(!started) {
    switch_hyperbolic = true;
    dont_face_pc = true;
    nohud = true;
    rug::texturesize = 2048;
    #if ISANDROID
    rug::vertex_limit = 5000;
    #else
    rug::vertex_limit = 20000;
    #endif
    rug::rug_perspective = true;
    vid.wallmode = 3;
    vid.monmode = 2;
    vid.axes = 0;
    if(ISANDROID)
      stereo::mode = stereo::sLR,
      rug::ruggo = 0.1;
    }

  if(switch_hyperbolic) {
    if(geometry == gNormal) {
      sightrange = 15;
      targetgeometry = gEuclid; restartGame('g');
      vid.scale = .25;
      rug::gwhere = gSphere;
      rug::model_distance = 2;
      rug::modelscale = .35;
      }
    else {
      sightrange = 7;
      targetgeometry = gNormal; restartGame('g');
      vid.scale = 1;
      rug::gwhere = gEuclid;
      rug::model_distance = 2;
      rug::modelscale = 1;
      }
    }

  restartGame();
  
  celllister cl(cwt.c, 13, 1000000, NULL);
  for(cell *c: cl.lst) checkTide(c);
  
  for(eMonster m: { 
      moPrincessArmed, moEagle, moReptile, moGhost, moSalamander, moPirate, moMouse, moSparrowhawk, moGadfly, moButterfly, moTerraWarrior, moSleepBull, moHunterDog,
      moGoblin, moYeti, moDesertman, moRoseBeauty, moFalsePrincess, moTameBomberbird, moAlbatross, moFireElemental
      }) {
    for(int i=0; i<100; i++) {
      cell *c = cl.lst[hrand(size(cl.lst))];
      if(passable_for(m, c, NULL, 0) && c != cwt.c) {
        c->monst = m;
        c->hitpoints = 7;
        break;
        }
      }
    }

  for(eItem m: { itGold, itDiamond, itOrbSafety, itOrbFlash, itDodeca, itBone, itKey }) {
    for(int i=0; i<100; i++) {
      cell *c = cl.lst[hrand(size(cl.lst))];
      if(passable(c, NULL, 0) && c != cwt.c) {
        c->item = m;
        break;
        }
      }
    }
  
  popScreenAll();
  clearMessages();
  calcparam();
  
  if(ISMOBWEB) {
    rug::renderlate = 10;
    rug::renderonce = true;
    }
 
  if(started) {
    if(rug::rugged) rug::close(), rug::init();
    }
  else {
    started = true;
    drawthemap();
    rug::init();
    } 
  }

string XLAT1(string x);

void showSphereScenes() {
  gamescreen(2);

  getcstat = ' ';
  
  dialog::init();
  
  dialog::init("Virtual Crocheting", 0xC00000, 200, 100);
  dialog::addInfo(XLAT1("Which texture to use?"), 0xFFFFFF);
  dialog::addBreak(100);

  dialog::addItem(XLAT1("Desert"), '1');
  dialog::addItem(XLAT1("Volcanic Wasteland"), '2');
  dialog::addItem(XLAT1("Galápagos"), '3');
  dialog::addItem(XLAT1("Windy Plains"), '4');
  dialog::addItem(XLAT1("Elemental Planes"), '5');
  dialog::addItem(XLAT("rainbow landscape"), 'a');
  dialog::addItem(XLAT("football"), 'b');
  
  dialog::display();
  clearMessages();

  timerstart = time(NULL);
  
  keyhandler = [] (int sym, int uni) {
    dialog::handleNavigation(sym, uni);
    if(uni == '1') {
      enable_rug(laDesert);
      }
    else if(uni == '2') {
      enable_rug(laVolcano);
      }
    else if(uni == '3') {
      enable_rug(laTortoise);
      }
    else if(uni == '4') {
      enable_rug(laWhirlwind);
      }
    else if(uni == '5') {
      enable_rug(laElementalWall);
      }
    else if(uni == 'a') {
      patterns::whichCanvas = 'l';
      enable_rug(laCanvas);
      }
    else if(uni == 'b') {
      patterns::whichCanvas = 'F';
      enable_rug(laCanvas);
      }
    else if(!started) ;
    else if(doexiton(sym, uni)) popScreen();
    };
  }

void showSphereMenu() {
  gamescreen(2);

  getcstat = ' ';
  
  dialog::init();
  
  dialog::init("Virtual Crocheting", 0xC00000, 200, 100);
  dialog::addBreak(100);

  dialog::addItem(XLAT1("Select a texture"), '1');
  
  dialog::addBreak(100);
  dialog::addItem(XLAT("configure"), 'r');
  dialog::addBoolItem(XLAT("auto-move"), rug::ruggo, 'm');
  dialog::addBoolItem(XLAT("hyperbolic crocheting"), geometry == gNormal, 'h');
  dialog::addItem(XLAT("HyperRogue menu"), 'v');

  dialog::display();
  clearMessages();

  timerstart = time(NULL);
  
  keyhandler = [] (int sym, int uni) {
    dialog::handleNavigation(sym, uni);
    if(uni == '1') {
      pushScreen(showSphereScenes);
      }
    else if(uni == 'x') {
      odsvideo(1752);
      }
    else if(uni == 'r') 
      rug::select();
    else if(uni == 'v') 
      pushScreen(showMainMenu);
    else if(uni == 'h') {
      enable_rug(specialland, true);
      }
    else if(uni == 'm') {
      if(rug::ruggo) rug::ruggo = 0;
      else rug::ruggo = .1;
      }
    else if(doexiton(sym, uni)) popScreen();
    };
  }

void pres_config() {
  autocheat = true;
#if ISANDROID
  if(true) {
#else
  if(arg::curphase == 3) {
#endif
    popScreenAll();
    pushScreen(showSphereScenes);
    showstartmenu = false;
    }
  }

bool pres_handleKey(int sym, int uni) {
  if((cmode & sm::NORMAL))
    if(sym == 'v' || sym == SDLK_ESCAPE) {
      pushScreen(showSphereMenu);
      return true;
      }
  return false;
  }


int phooks = 
  0
#if !ISANDROID
  + addHook(hooks_config, 0, pres_config)
#endif
  + addHook(hooks_handleKey, 0, pres_handleKey);

  
